
import org.lwjgl.PointerBuffer;
import org.lwjgl.Sys;
import org.lwjgl.opengl.GLContext;
import org.lwjgl.system.glfw.ErrorCallback;
import org.lwjgl.system.glfw.GLFWimage;
import org.lwjgl.system.glfw.MonitorCallback;
import org.lwjgl.system.glfw.WindowCallback;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.io.File;

import static org.lwjgl.opengl.GL11.*;
import static org.lwjgl.system.MemoryUtil.*;
import static org.lwjgl.system.glfw.GLFW.*;


public final class test1 extends WindowCallback {

    private boolean escPressed = false;

	private test1() {
    }

	public static void main(String[] args) {
        test1 t = new test1();
        t.demo();
	}

	private void demo() {

        glfwSetErrorCallback(ErrorCallback.Util.getDefault());
		if ( glfwInit() == 0 )
			throw new IllegalStateException("Failed to initialize GLFW.");
                    
		glfwDefaultWindowHints();
		glfwWindowHint(GLFW_VISIBLE, GL_FALSE);

		long window = glfwCreateWindow(640, 480, "GLFW quick 'n dirty test", NULL, NULL);
		if ( window == 0L )
			throw new IllegalStateException("Failed to create GLFW window.");
        
		try {
			IOUtil.ImageData pixels = IOUtil.ioImageResourceToByteBuffer("data/cursor.png");

			ByteBuffer img = GLFWimage.malloc(pixels.width, pixels.height, pixels.data);
			long cursor = glfwCreateCursor(img, 0, 8);

			glfwSetCursor(window, cursor);
		} catch (IOException e) {
			e.printStackTrace();
		}

		glfwSetMonitorCallback(MonitorCallback.Util.getDefault());

        WindowCallback.set(window, this);

		glfwMakeContextCurrent(window);
		GLContext.createFromCurrent();

        int texture=0;

        try {
			IOUtil.ImageData pixels = IOUtil.ioImageResourceToByteBuffer("data/wall.png");

            texture=glGenTextures();
            glBindTexture(GL_TEXTURE_2D, texture);
            glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, pixels.width, pixels.height, 0,
                    GL_RGB, GL_UNSIGNED_BYTE, pixels.data);

            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);

            
		} catch (IOException e) {
			e.printStackTrace();
		}

		glfwShowWindow(window);
		glfwSwapInterval(1);

		glClearColor(0.25f, 0.5f, 1.0f, 0.0f);
        glEnable(GL_TEXTURE_2D);
        
        // "main loop" of the demo
        float a=0;
		while ( glfwWindowShouldClose(window)==0 ) {

			glfwPollEvents();
            
            if (escPressed) {   // alt-f4/close widget but not escape key
                glfwSetWindowShouldClose(window, GL_FALSE);
                escPressed = false;
            }
        
            a+=0.05f; // multiply by delta time!

			glClear(GL_COLOR_BUFFER_BIT);

            glBindTexture(GL_TEXTURE_2D, texture);
            glBegin(GL_TRIANGLES);
              glColor4f(1f,1f,1f,1f);
              glTexCoord2f(0,0); 
              glVertex2f(0, 0);

              glColor4f(1f,0f,0f,1f);
              glTexCoord2f(1f,1f); 
              glVertex2f((float)(.75*Math.sin(a)), (float)(.75*Math.cos(a)));

              glColor4f(0f,0f,1f,1f);
              glTexCoord2f(0,1f); 
              glVertex2f((float)(.75*Math.cos(a/2)), (float)(.75*Math.sin(a/2)));
            glEnd();
            
			glfwSwapBuffers(window);
		}


	}

	private static String getModState(int mods) {
		if ( mods == 0 )
			return "";

		StringBuilder modState = new StringBuilder(16);
		if ( (mods & GLFW_MOD_SHIFT) != 0 )
			modState.append("SHIFT+");
		if ( (mods & GLFW_MOD_CONTROL) != 0 )
			modState.append("CONTROL+");
		if ( (mods & GLFW_MOD_ALT) != 0 )
			modState.append("ALT+");
		if ( (mods & GLFW_MOD_SUPER) != 0 )
			modState.append("SUPER+");

		return modState.toString();
	}

	private static void printEvent(long window, String format, Object... args) {
		Object[] formatArgs = new Object[2 + args.length];

		formatArgs[0] = glfwGetTime();
		formatArgs[1] = window;
		System.arraycopy(args, 0, formatArgs, 2, args.length);

		System.out.format("%.3f: Window [%d] " + format + "%n", formatArgs);
	}


    // events

    @Override
    public void windowPos(long window, int xpos, int ypos) {
        printEvent(window, "moved to %d, %d", xpos, ypos);
    }

    @Override
    public void windowSize(long window, int width, int height) {
        printEvent(window, "resized to %d x %d", width, height);
    }

    @Override
    public void windowClose(long window) {
        printEvent(window, "closed");
    }

    @Override
    public void windowRefresh(long window) {
        printEvent(window, "refreshed");
    }

    @Override
    public void windowFocus(long window, int focused) {
        printEvent(window, focused == 0 ? "lost focus" : "gained focus");
    }

    @Override
    public void windowIconify(long window, int iconified) {
        printEvent(window, iconified == 0 ? "restored" : "iconified");
    }

    @Override
    public void framebufferSize(long window, int width, int height) {
        printEvent(window, "framebuffer resized to %d x %d", width, height);
    }

    @Override
    public void key(long window, int key, int scancode, int action, int mods) {
        String state;
        switch ( action ) {
            case GLFW_RELEASE:
                state = "released";
                if (key==GLFW_KEY_ESCAPE) escPressed = true;
                break;
            case GLFW_PRESS:
                state = "pressed";
                break;
            case GLFW_REPEAT:
                state = "repeated";
                break;
            default:
                throw new IllegalArgumentException(String.format("Unsupported key action: 0x%X", action));
        }

        printEvent(window, "key %s[0x%X - %d] was %s", getModState(mods), key, scancode, state);

        if ( key == GLFW_KEY_ESCAPE && action == GLFW_RELEASE )
            glfwSetWindowShouldClose(window, 1);
    }

    @Override
    public void character(long window, int codepoint) {
        printEvent(window, "char %s", Character.toString((char)codepoint));
    }

    @Override
    public void charMods(long window, int codepoint, int mods) {
        printEvent(window, "char mods %s%s", getModState(mods), Character.toString((char)codepoint));
    }

    @Override
    public void mouseButton(long window, int button, int action, int mods) {
        String state;
        switch ( action ) {
            case GLFW_RELEASE:
                state = "released";
                break;
            case GLFW_PRESS:
                state = "pressed";
                break;
            default:
                throw new IllegalArgumentException(String.format("Unsupported mouse button action: 0x%X", action));
        }
        printEvent(window, "mouse button %s[0x%X] was %s", getModState(mods), button, state);
    }

    @Override
    public void cursorPos(long window, double xpos, double ypos) {
// too much spew!!        printEvent(window, "cursor moved to %f, %f", xpos, ypos);
    }

    @Override
    public void cursorEnter(long window, int entered) {
        printEvent(window, "cursor %s", entered == 0 ? "left" : "entered");
    }

    @Override
    public void scroll(long window, double xoffset, double yoffset) {
        printEvent(window, "scroll by %f, %f", xoffset, yoffset);
    }

    @Override
    public void drop(long window, int count, long names) {
        printEvent(window, "drop %d file%s", count, count == 1 ? "" : "s");

        PointerBuffer nameBuffer = memPointerBuffer(names, count);
        for ( int i = 0; i < count; i++ ) {
            System.out.format("\t%d: %s%n", i + 1, memDecodeUTF8(memByteBufferNT1(nameBuffer.get(i))));
        }
    }


}
